import java.security.SecureRandom;

public class OneTimePad {
	     
	SecureRandom random;

	public OneTimePad() {
		try { random = SecureRandom.getInstance("SHA1PRNG"); }
		catch (Exception e) {
			System.out.println("Exception : "+e.toString());
		}
	};

	public byte[] encode(byte[] key, byte[] message) {
		if(key.length < message.length) throw new IllegalArgumentException("length of key must be >= length of message");
		byte [] c = new byte[key.length];
		for(int i =0;i< key.length;i++) {
			c[i] = (byte)(key[i] ^ message[i]);
		}
		return c;
	}

	public byte[] generateKey (int nbOctets) {
		byte key[] = new byte[nbOctets];
		random.nextBytes(key);

		return key;
	}

	public byte[] generateKey (byte[] message) {
		byte key[] = new byte[message.length];
		random.nextBytes(key);

		return key;
	}

	public byte[] encode_ECB_XOR(byte[] key, byte[] message) {
		byte [] encryptedMessage = new byte[message.length];

		int tailleClef = key.length;
		// On travaille ensuite sur des blocs de la taille de la clef
		byte[] bloc = new byte[tailleClef];

		// pour tous les blocs , on code...
		int nbBlocks = message.length/tailleClef+1;
		int tailleBlock = tailleClef;
		for (int i=0; i< nbBlocks ;i++) {
			if (i== nbBlocks-1)
				tailleBlock = message.length % tailleClef;
			System.arraycopy (message, i*tailleClef, bloc, 0, tailleBlock);
			byte[] encryptedMessageBloc = encode(bloc,key);	
			System.arraycopy (encryptedMessageBloc, 0, encryptedMessage, i*tailleClef, tailleBlock);
		}

		return encryptedMessage;

	}

	public byte[] decode_ECB_XOR(byte[] key, byte[] message) {
		return encode_ECB_XOR(key, message);
	}

}

